SystemOrganization addCategory: #'Pier-Blog-Model'!
SystemOrganization addCategory: #'Pier-Blog-Seaside'!

!GRPackage class methodsFor: '*pier-blog' stamp: 'lr 2/18/2010 10:32'!
pierBlog
	^ self new
		name: 'Pier-Blog';
		description: 'A blog extension supporting RSS feeds, posts with embedded media, public comments, etc.';
		addDependency: 'Pier-Model';
		addDependency: 'Pier-Seaside';
		url: #pierUrl;
		yourself! !

PRViewRenderer subclass: #PBRssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBRssRenderer methodsFor: 'private' stamp: 'NickAger 8/4/2011 12:31'!
linkRendererFor: aLink
	"Answer an instance of the most appropriate renderer for this link. If the link is internal and embedded, avoid the embedding and simply create a reference."

	| class |
	class := aLink isBroken
		ifTrue: [ PRBrokenRenderer ]
		ifFalse: [
			(aLink isEmbedded not
				or: [ aLink isInternal
				and: [ aLink target hasDocument
				and: [ visited includes: aLink target ] ] ])
					ifTrue: [ PRReferenceRenderer ]
					ifFalse: [ PBRssEmbeddedRenderer ] ].

	^ class parent: self! !

!PBRssRenderer methodsFor: 'visiting-document' stamp: 'lr 1/29/2007 23:31'!
visitAnchor: anObject! !

!PBRssRenderer methodsFor: 'visiting' stamp: 'lr 12/18/2008 07:47'!
visitLightBoxLink: aLink
! !

!PBRssRenderer methodsFor: 'visiting-document' stamp: 'lr 2/5/2007 21:58'!
visitParagraph: anObject
	html paragraph: [ self visitAll: anObject children ]! !

!PBRssRenderer methodsFor: 'visiting-document' stamp: 'lr 5/21/2009 09:53'!
visitValueLink: anObject
	"Ignore value links to avoid strange side-effects."! !

WAPresenter subclass: #PBSocialWidgetsAddThis
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBSocialWidgetsAddThis commentStamp: 'NickAger 6/16/2011 15:59' prior: 0!
I am display social widgets from http://www.addthis.com/.
To use:
 1) Edit the blog
 2) In "Social Sharing class" entry enter: PBSocialWidgetsAddThis
 3) Save changes
 4) Your blog entries should now contain the social widgets from http://www.addthis.com/.
!

!PBSocialWidgetsAddThis methodsFor: 'rendering' stamp: 'NickAger 11/22/2011 23:31'!
renderWidgetForEntry: anEntry on: html
	| entryContext url |
	entryContext := self context structure: anEntry.
	url := entryContext url withoutQuery withoutFragment.
	
	html div class: 'addthis_toolbox addthis_default_style '; attributeAt: 'addthis:url' put: url greaseString; with: [
      	html anchor attributeAt: 'fb:like:layout' put: 'button_count'; class: 'addthis_button_facebook_like'.
		html anchor class: 'addthis_button_twitter'.
		html anchor class: 'addthis_button_google_plusone'.
		html anchor class: 'addthis_button_email'.
		html anchor class: 'addthis_button_print'.
		html span class: 'addthis_separator'; with: '|'.
		html anchor class: 'addthis_button_compact' ]! !

!PBSocialWidgetsAddThis methodsFor: 'updating' stamp: 'NickAger 11/22/2011 23:31'!
updateRoot: anHtmlRoot 
	super updateRoot: anHtmlRoot.

	anHtmlRoot javascript url: 'http://s7.addthis.com/js/250/addthis_widget.js'! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/15/2007 21:06'!
isBlog
	^ false! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/14/2007 13:23'!
isComment
	^ false! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/14/2007 13:44'!
isPost
	^ false! !

PRRawView subclass: #PBRssView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

PBRssView subclass: #PBBlogRssView
	instanceVariableNames: 'blog tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBBlogRssView class methodsFor: 'testing' stamp: 'lr 10/2/2008 16:04'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isBlog ]! !

!PBBlogRssView class methodsFor: 'instance creation' stamp: 'lr 10/2/2008 16:05'!
new
	"This is an ugly hack to make already bookmarked blogs work properly."

	^ self name = #PBRssView
		ifTrue: [ PBEntriesRssView new ]
		ifFalse: [ super new ]! !

!PBBlogRssView methodsFor: 'accessing' stamp: 'lr 10/2/2008 15:33'!
blog
	^ blog ifNil: [ blog := self find: PBBlog ]! !

!PBBlogRssView methodsFor: 'initialization' stamp: 'NickAger 8/3/2011 22:24'!
initialRequest: aRequest
	super initialRequest: aRequest.
	tags := (aRequest queryFields at: 'tags' ifAbsent: [ '' ])
		findTokens: $,! !

!PBBlogRssView methodsFor: 'accessing-dynamic' stamp: 'lr 10/2/2008 15:34'!
link
	^ (self context structure: self blog) url! !

!PBBlogRssView methodsFor: 'rendering' stamp: 'sn 2/25/2013 16:11'!
renderDescription: aDocument on: rss
	rss description: [
		rss html: '<!![CDATA['.
		PBRssRenderer new
			start: aDocument in: self 
			on: (WAHtmlCanvas context: rss context).
		rss html: ']]>' ]! !

!PBBlogRssView methodsFor: 'rendering' stamp: 'lr 6/17/2010 09:41'!
renderRssOn: rss
	"Generate some standard information that should be present in all the feeds."

	rss title: self title; link: self link.
	self renderDescription: self blog document on: rss.
	rss generator: 'Pier Blog'.
	rss language: self blog language.
	self blog tags do: [ :each | rss category: each ].
	self blog copyright isNil
		ifFalse: [ rss copyright: self blog copyright ].
	self blog managingEditor isNil
		ifFalse: [ rss managingEditor: self blog managingEditor ].
	self blog webMaster isNil
		ifFalse: [ rss webMaster: self blog webMaster ]! !

!PBBlogRssView methodsFor: 'accessing-dynamic' stamp: 'lr 10/2/2008 15:34'!
title
	^ self blog feedTitle ifNil: [ self blog title ]! !

PBBlogRssView subclass: #PBCommentsRssView
	instanceVariableNames: 'comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBCommentsRssView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:56'!
isAbstract
	^ false! !

!PBCommentsRssView class methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:00'!
label
	^ 'Comments (RSS)'! !

!PBCommentsRssView methodsFor: 'accessing' stamp: 'lr 1/26/2008 12:55'!
comments
	^ comments ifNil: [ comments := self findComments ]! !

!PBCommentsRssView methodsFor: 'private' stamp: 'lr 4/14/2011 19:25'!
findComments
	| items |
	items := self blog allCommentsIn: self context.
	tags isEmpty ifFalse: [
		items := items select: [ :comm | 
			| post |
			post := comm findAncestor: [ :each | each isKindOf: PBPost ].
			post notNil and: [ post tags anySatisfy: [ :each | tags includes: each ] ] ] ].
	items := items last: (self blog itemCount min: items size).
	^ items reversed! !

!PBCommentsRssView methodsFor: 'rendering' stamp: 'lr 6/17/2010 09:41'!
renderComment: aComment on: rss
	| post |
	post := aComment parents reverse
		detect: [ :each | each isPost ].
	rss title: 'Comment on ' , post title.
	rss link: ((self context structure: post)
		url fragment: aComment uuid).
	aComment author isNil
		ifFalse: [ rss creator: aComment author ].
	rss publicationDate: (RRRfc822DateTime
		newDateAndTime: aComment publication).
	rss guid
		beNoPermaLink;
		with: aComment uuid.
	self renderDescription: aComment document on: rss! !

!PBCommentsRssView methodsFor: 'rendering' stamp: 'lr 2/5/2007 21:44'!
renderRssOn: rss
	super renderRssOn: rss.
	self comments isEmpty ifTrue: [ ^ self ].
	rss lastBuildDate: (RRRfc822DateTime
		newDateAndTime: self comments last publication).
	self comments do: [ :each |
		rss item: [ self renderComment: each on: rss ] ]! !

!PBCommentsRssView methodsFor: 'accessing-dynamic' stamp: 'lr 2/5/2007 21:46'!
title
	^ 'Comments for ' , super title! !

PBBlogRssView subclass: #PBEntriesRssView
	instanceVariableNames: 'posts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBEntriesRssView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:55'!
isAbstract
	^ false! !

!PBEntriesRssView class methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:00'!
label
	^ 'Entries (RSS)'! !

!PBEntriesRssView methodsFor: 'private' stamp: 'NickAger 8/3/2011 22:24'!
findPosts
	| items |
	items := self blog allPostsIn: self context.
	tags isEmptyOrNil
		ifFalse: [ items := items select: [ :post | post tags anySatisfy: [ :each | tags includes: each ] ] ].
	items := items last: (self blog itemCount min: items size).
	^ items reversed! !

!PBEntriesRssView methodsFor: 'responding' stamp: 'jf 11/4/2009 11:16'!
handle: aRequestContext
	(self shouldForward: aRequestContext)
		ifFalse: [ super handle: aRequestContext ]
		ifTrue: [
			aRequestContext responseGenerator
				redirectTo: self blog feedForward;
				respond ]! !

!PBEntriesRssView methodsFor: 'accessing' stamp: 'lr 2/5/2007 21:42'!
posts
	^ posts ifNil: [ posts := self findPosts ]! !

!PBEntriesRssView methodsFor: 'rendering' stamp: 'lr 6/17/2010 09:59'!
renderPost: aPost on: rss
	| enclosure |
	rss title: aPost title.
	rss link: (self context structure: aPost) url.
	rss comments: (self context structure: aPost) url.
	rss commentRss: (self context
		structure: self blog
		view: PBCommentsRssView) url.
	rss publicationDate: (RRRfc822DateTime
		newDateAndTime: aPost publication).
	aPost tags
		do: [ :each | rss category: each ].
	self renderDescription: aPost document on: rss.
	aPost author isNil
		ifFalse: [ rss creator: aPost author ].
	rss guid
		beNoPermaLink;
		with: aPost uuid.
	(enclosure := aPost enclosure) isNil ifFalse: [
		rss enclosure
			url: enclosure file url;
			length: enclosure file filesize;
			type: enclosure file mimetype ].
	aPost sourceUrl isNil ifFalse: [
		rss source
			url: aPost sourceUrl;
			with: aPost sourceTitle ]! !

!PBEntriesRssView methodsFor: 'rendering' stamp: 'lr 2/5/2007 21:42'!
renderRssOn: rss
	super renderRssOn: rss.
	self posts isEmpty ifTrue: [ ^ self ].
	rss lastBuildDate: (RRRfc822DateTime
		newDateAndTime: self posts last publication).
	self posts do: [ :each |
		rss item: [ self renderPost: each on: rss ] ]! !

!PBEntriesRssView methodsFor: 'private' stamp: 'lr 1/5/2013 16:10'!
shouldForward: aContext
	(self blog feedForward isNil or: [ self blog feedForward isEmpty ])
		ifTrue: [ ^ false ].
	(self requestContext request fields includesKey: 'noforward')
		ifTrue: [ ^ false ].
	(self requestContext request userAgent notNil and: [ self requestContext request userAgent includesSubString: 'FeedBurner' ])
		ifTrue: [ ^ false ].
	^ true! !

PBRssView subclass: #PBHistoryRssView
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

PBHistoryRssView subclass: #PBChangesRssView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBChangesRssView class methodsFor: 'testing' stamp: 'lr 9/28/2009 10:04'!
isAbstract
	^ false! !

!PBChangesRssView class methodsFor: 'accessing' stamp: 'lr 10/2/2008 16:30'!
label
	^ 'Changes (RSS)'! !

!PBChangesRssView methodsFor: 'testing' stamp: 'lr 10/2/2008 16:35'!
isVisible: aContext
	^ aContext command isEdit and: [ super isVisible: aContext ]! !

!PBChangesRssView methodsFor: 'rendering-parts' stamp: 'NickAger 1/22/2012 11:16'!
renderData: aContext on: html
	aContext command magritteDescription do: [ :each |
		each isDocumentDescription ifTrue: [
			PBRssRenderer new
				start: (aContext 	command readUsing: each)
				in: self on: html ] ]! !

!PBChangesRssView methodsFor: 'accessing' stamp: 'lr 9/16/2009 12:52'!
titleFor: aContext
	^ aContext structure title! !

PBHistoryRssView subclass: #PBDiffRssView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBDiffRssView class methodsFor: 'testing' stamp: 'lr 9/28/2009 10:04'!
isAbstract
	^ false! !

!PBDiffRssView class methodsFor: 'accessing' stamp: 'lr 9/27/2009 19:20'!
label
	^ 'Diff (RSS)'! !

!PBDiffRssView methodsFor: 'testing' stamp: 'lr 9/27/2009 20:13'!
isFiltered
	^ false! !

!PBDiffRssView methodsFor: 'testing' stamp: 'lr 9/28/2009 08:59'!
isVisible: aContext
	^ aContext command isEdit and: [ super isVisible: aContext ]! !

!PBDiffRssView methodsFor: 'rendering-parts' stamp: 'NickAger 1/22/2012 11:17'!
renderData: aContext on: html
	| previous |
	previous := self 
		previousContextOf: aContext
		matching: [ :each | each structure == aContext structure ].
	aContext command magritteDescription do: [ :each |
		each isDocumentDescription ifTrue: [
			| source target |
			source := previous isNil
				ifFalse: [ each toString: (previous command readUsing: each) ].
			target := each toString: (aContext command readUsing: each).
			html render: (PRWordDiffAlgorithm from: source to: target) ] ]! !

!PBDiffRssView methodsFor: 'accessing' stamp: 'lr 9/28/2009 08:59'!
titleFor: aContext
	^ aContext structure title! !

!PBHistoryRssView class methodsFor: 'testing' stamp: 'lr 9/28/2009 10:03'!
isAbstract
	^ true! !

!PBHistoryRssView class methodsFor: 'accessing' stamp: 'lr 9/28/2009 09:19'!
label
	^ 'Log (RSS)'! !

!PBHistoryRssView methodsFor: 'private' stamp: 'lr 9/27/2009 20:17'!
buildItems
	| result |
	result := OrderedCollection new.
	self context kernel persistency reverseDo: [ :each |
		(self isVisible: each) ifTrue: [
			(self isFiltered not
				or: [ result isEmpty 
				or: [ result last structure ~= each structure 
				or: [ result last command class ~= each command class ] ] ]) ifTrue: [
					result addLast: each.
					result size < self maxSize
						ifFalse: [ ^ result ] ] ] ].
	^ result! !

!PBHistoryRssView methodsFor: 'testing' stamp: 'lr 9/27/2009 20:13'!
isFiltered
	^ true! !

!PBHistoryRssView methodsFor: 'testing' stamp: 'lr 10/2/2008 16:35'!
isVisible: aContext
	^ (aContext structure parents includes: self context structure) and: [ aContext isValidCommand: aContext structure viewCommandClass ]! !

!PBHistoryRssView methodsFor: 'accessing' stamp: 'lr 9/27/2009 19:41'!
items
	^ items ifNil: [ items := self buildItems ]! !

!PBHistoryRssView methodsFor: 'accessing' stamp: 'lr 10/6/2008 16:32'!
maxSize
	^ 25! !

!PBHistoryRssView methodsFor: 'rendering-parts' stamp: 'jf 11/3/2009 11:12'!
renderBasic: aContext on: rss
	rss title: (self titleFor: aContext).
	rss link: (self urlFor: aContext).
	rss publicationDate: (RRRfc822DateTime
		newDateAndTime: aContext command timestamp).
	rss guid 
		beNoPermaLink;
		with: ((self urlFor: aContext)
			fragment: aContext command timestamp 
				asSeconds greaseString;
			yourself)! !

!PBHistoryRssView methodsFor: 'rendering-parts' stamp: 'jf 9/14/2009 15:20'!
renderBody: aContext on: rss
	rss description: [
		rss html: '<!![CDATA['.
		self 
			renderData: aContext
			on: (WARenderCanvas context: rss context).
		rss html: ']]>' ]! !

!PBHistoryRssView methodsFor: 'rendering-parts' stamp: 'NickAger 1/22/2012 11:17'!
renderData: aContext on: html
	| data | 
	html definitionList: [
		aContext command magritteDescription do: [ :each |
			html definitionTerm: each label.
			html definitionData: [
				data := aContext command readUsing: each.
				each isDocumentDescription
					ifFalse: [ html render: (each toString: data) ]
					ifTrue: [
						PBRssRenderer new
							start: data in: self 
							on: html ] ] ] ]! !

!PBHistoryRssView methodsFor: 'rendering' stamp: 'lr 10/2/2008 16:00'!
renderItem: aContext on: rss
	rss item: [
		self renderBasic: aContext on: rss.
		self renderUser: aContext on: rss.
		self renderTags: aContext on: rss.
		self renderBody: aContext on: rss ]! !

!PBHistoryRssView methodsFor: 'rendering' stamp: 'lr 10/6/2008 16:12'!
renderRssOn: rss
	rss title: self title; description: self label; link: self url.
	self items do: [ :each | self renderItem: each on: rss ]! !

!PBHistoryRssView methodsFor: 'rendering-parts' stamp: 'lr 10/2/2008 16:00'!
renderTags: aContext on: rss
	aContext structure tags
		do: [ :each | rss category: each ].
	rss category: aContext structure cssClass.
	rss category: aContext command cssClass! !

!PBHistoryRssView methodsFor: 'rendering-parts' stamp: 'lr 10/2/2008 16:00'!
renderUser: aContext on: rss
	| user |
	user := aContext propertyAt: #user ifAbsent: [ ^ self ].
	user isNil ifFalse: [ ^ rss creator: user name ]! !

!PBHistoryRssView methodsFor: 'accessing' stamp: 'lr 10/2/2008 16:34'!
title
	^ self titleFor: self context! !

!PBHistoryRssView methodsFor: 'accessing' stamp: 'jf 9/14/2009 15:06'!
titleFor: aContext
	^ (aContext command label copyUpTo: $() trimBoth , ': ' , aContext structure title! !

!PBHistoryRssView methodsFor: 'accessing' stamp: 'lr 10/2/2008 16:44'!
url
	^ self urlFor: self context! !

!PBHistoryRssView methodsFor: 'accessing' stamp: 'lr 10/2/2008 16:48'!
urlFor: aContext
	^ (aContext view: aContext structure viewComponentClass) url! !

PBHistoryRssView subclass: #PBLogRssView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBLogRssView class methodsFor: 'testing' stamp: 'lr 9/28/2009 10:04'!
isAbstract
	^ false! !

!PBLogRssView class methodsFor: 'accessing' stamp: 'lr 9/28/2009 10:04'!
label
	^ 'Log (RSS)'! !

!PBRssView methodsFor: 'private' stamp: 'lr 9/28/2009 09:08'!
previousContextOf: aContext matching: aBlock
	| current previous |
	current := self items
		indexOf: aContext
		ifAbsent: [ ^ nil ].
	current + 1 to: self items size do: [ :index |
		previous := self items at: index.
		(aBlock value: previous)
			ifTrue: [ ^ previous ] ].
	^ nil! !

!PBRssView methodsFor: 'rendering' stamp: 'lr 10/2/2008 15:40'!
renderRssOn: rss
	self subclassResponsibility! !

!PBRssView methodsFor: 'responding' stamp: 'jf 11/4/2009 12:34'!
respondUsing: aResponse
	super respondUsing: aResponse.
	aResponse
		contentType: (WAMimeType
			applicationRssXml
			charset: RRRssRoot defaultCharSet;
			yourself);
		doNotCache;
		nextPutAll: (RRRssRenderCanvas builder
			fullDocument: true;
			render: [ :canvas | self renderRssOn: canvas ])! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:51'!
visitBlog: anObject
	self visitCase: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:11'!
visitComment: anObject
	self visitEntry: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:51'!
visitEntry: anObject
	self visitCase: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 16:08'!
visitPost: anObject
	self visitEntry: anObject! !

PRDefaultView subclass: #PBHtmlView
	instanceVariableNames: 'blog socialSharingWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

PBHtmlView subclass: #PBBlogHtmlView
	instanceVariableNames: 'posts batcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBBlogHtmlView class methodsFor: 'testing' stamp: 'lr 1/15/2007 21:05'!
isAbstract
	^ false! !

!PBBlogHtmlView class methodsFor: 'testing' stamp: 'lr 1/19/2007 19:13'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isBlog ]! !

!PBBlogHtmlView class methodsFor: 'accessing' stamp: 'lr 9/4/2008 13:47'!
label
	^ super label , ' (Blog)'! !

!PBBlogHtmlView methodsFor: 'accessing-dynamic' stamp: 'lr 2/5/2007 19:27'!
batcher
	^ batcher ifNil: [ batcher := WABatchedList new items: self posts; batchSize: 5 ]! !

!PBBlogHtmlView methodsFor: 'accessing-dynamic' stamp: 'NickAger 6/16/2011 15:23'!
children
	^ super children, (Array with: self batcher) , (self batcher batch gather: [ :each | each componentsIn: self context ])! !

!PBBlogHtmlView methodsFor: 'accessing' stamp: 'lr 1/14/2008 10:17'!
posts
	"Answer a default collection of posts."
	
	^ posts ifNil: [ posts := super posts reversed ]! !

!PBBlogHtmlView methodsFor: 'accessing' stamp: 'lr 11/6/2007 18:52'!
posts: aCollection
	"Display aCollection of posts in the receiver, presumeably this is a subset of the currently available posts."
	
	posts := aCollection asSortedCollection: [ :a :b | a publication > b publication ].
	batcher := nil! !

!PBBlogHtmlView methodsFor: 'rendering' stamp: 'lr 2/5/2007 19:30'!
renderBatcherOn: html
	(self batcher isOnFirstPage and: [ self batcher isOnLastPage ])
		ifFalse: [ html div class: 'batcher'; with: self batcher ]! !

!PBBlogHtmlView methodsFor: 'rendering' stamp: 'lr 2/5/2007 20:05'!
renderContentOn: html
	super renderContentOn: html.
	self renderPosts: self batcher batch on: html.
	self renderBatcherOn: html.
	self renderRssOn: html! !

!PBHtmlView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:55'!
isAbstract
	^ true! !

!PBHtmlView methodsFor: 'accessing' stamp: 'lr 2/5/2007 19:35'!
blog
	^ blog ifNil: [ blog := self find: PBBlog ]! !

!PBHtmlView methodsFor: 'as yet unclassified' stamp: 'NickAger 6/16/2011 15:23'!
children
	^ self socialSharingWidget isNil 
		ifTrue: [ #() ]
		ifFalse: [ Array with: self socialSharingWidget ]! !

!PBHtmlView methodsFor: 'actions' stamp: 'lr 2/18/2009 16:54'!
filter: aString
	| newContext component |
	newContext := self context structure: self blog.
	component := newContext command viewComponent.
	component posts: (component posts
		select: [ :each | each tags includes: aString ]).
	self context: newContext! !

!PBHtmlView methodsFor: 'accessing' stamp: 'lr 1/14/2008 10:15'!
posts
	"Answer the currently displayed blog posts."
	
	^ self blog allPostsIn: self context! !

!PBHtmlView methodsFor: 'rendering-meta' stamp: 'lr 3/9/2007 22:05'!
renderAuthor: anEntry on: html
	anEntry author ifNil: [ ^ self ].
	html span
		class: 'author';
		with: 'by ' , anEntry author.
	html text: ' '! !

!PBHtmlView methodsFor: 'rendering-meta' stamp: 'NickAger 7/16/2011 21:12'!
renderComment: anEntry on: html
	| comments |
	self context structure isBlog ifFalse: [ ^ self ].
	comments := anEntry allCommentsIn: self context.
	html anchor
		class: 'comment';
		goto: (self context
			structure: (self context structure isBlog
				ifTrue: [ anEntry ]
				ifFalse: [ anEntry parent ]));
		fragment: 'comments';
		with: (comments isEmpty ifTrue: [ '' ] ifFalse: [ comments size pluralize: ' comment' ]).
	html text: ' '! !

!PBHtmlView methodsFor: 'rendering' stamp: 'lr 5/25/2009 11:37'!
renderHeading: aPost on: html 
	html heading level: 1; with: [
		html anchor
			name: aPost uuid.
		html anchor
			goto: (self context structure: aPost);
			with: [ html html: aPost title ] ]! !

!PBHtmlView methodsFor: 'rendering-meta' stamp: 'lr 1/19/2008 21:09'!
renderLink: anEntry on: html
	html anchor
		class: 'link';
		url: (anEntry isPost
			ifTrue: [ (self context structure: anEntry) url ]
			ifFalse: [
				(self context
					structure: (anEntry parents reverse
						detect: [ :each | each isPost ]))
					url fragment: anEntry uuid ]);
		with: 'link'.
	html text: ' '! !

!PBHtmlView methodsFor: 'rendering' stamp: 'NickAger 6/16/2011 13:59'!
renderMeta: anEntry on: html
	html div class: 'meta'; with: [
		html text: 'Posted '.
		self renderAuthor: anEntry on: html.
		self renderPublication: anEntry on: html.
		self renderTags: anEntry on: html.
		self renderComment: anEntry on: html.
		self renderLink: anEntry on: html.
		self renderSocialSharing: anEntry on: html ]! !

!PBHtmlView methodsFor: 'rendering' stamp: 'lr 7/23/2008 21:48'!
renderPost: aPost on: html 
	html div class: 'post'; with: [ 
		self renderHeading: aPost on: html.
		self render: aPost on: html.
		self renderMeta: aPost on: html ]! !

!PBHtmlView methodsFor: 'rendering' stamp: 'lr 11/10/2008 13:32'!
renderPosts: aCollection on: html
	html div class: 'posts'; with: [
		aCollection do: [ :each |
			self renderPost: each on: html ] ]! !

!PBHtmlView methodsFor: 'rendering-meta' stamp: 'lr 3/19/2007 20:12'!
renderPublication: anEntry on: html
	anEntry publication ifNil: [ ^ self ].
	html span
		class: 'publication';
		with: 'at ' , anEntry publication date printString ,
			', ' , anEntry publication time printMinutes.
	html text: ' '! !

!PBHtmlView methodsFor: 'rendering' stamp: 'damiencassou 11/18/2008 08:36'!
renderRssOn: html
	"If you modify this method, please also modify PBPostTicker>>#renderRssOn:"
	html div class: 'subscribe'; with: [
		html anchor
			url: (self context
				structure: self blog
				view: PBEntriesRssView)
					url;
			with: 'Entries (RSS)'.
		html span class: 'rssComments'; with: [
			html text: ' and '.
				html anchor
					url: (self context
						structure: self blog
						view: PBCommentsRssView)
							url;
					with: 'Comments (RSS)' ]]! !

!PBHtmlView methodsFor: 'rendering' stamp: 'NickAger 11/23/2011 10:28'!
renderSocialSharing: anEntry on: html
	self socialSharingWidget notNil ifTrue: [
		html div
			class: 'socialSharingWidget';
			with: [
				self socialSharingWidget renderWidgetForEntry: anEntry on: html ] ]! !

!PBHtmlView methodsFor: 'rendering-meta' stamp: 'lr 11/6/2007 18:55'!
renderTags: anEntry on: html
	anEntry isPost ifFalse: [ ^ self ].
	anEntry tags isEmpty ifTrue: [ ^ self ].
	html span class: 'tags'; with: [
		html text: 'with tags '.
		anEntry tags
			do: [ :each |
				html anchor
					callback: [ self filter: each ];
					with: each ]
			separatedBy: [ html text: ', ' ] ].
	html text: ' '! !

!PBHtmlView methodsFor: 'accessing' stamp: 'NickAger 2/2/2012 18:15'!
socialSharingWidget
	^ socialSharingWidget ifNil: [
		self blog socialSharingWidgetClassName notNil 
			ifTrue: [ socialSharingWidget :=  (GRPlatform current magritteClassNamed: self blog socialSharingWidgetClassName) new ]
			ifFalse: [ nil ] ]! !

!PBHtmlView methodsFor: 'updating' stamp: 'lr 2/6/2007 18:07'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot rss
		title: self blog feedTitle;
		url: (self context
			structure: self blog
			view: PBEntriesRssView)
				url! !

PBHtmlView subclass: #PBPostHtmlView
	instanceVariableNames: 'post comment command component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostHtmlView class methodsFor: 'testing' stamp: 'lr 1/29/2007 13:37'!
isAbstract
	^ false! !

!PBPostHtmlView class methodsFor: 'testing' stamp: 'lr 1/29/2007 13:37'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isPost ]! !

!PBPostHtmlView class methodsFor: 'accessing' stamp: 'lr 9/4/2008 13:47'!
label
	^ super label , ' (Post)'! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 2/12/2007 19:07'!
buildCommand
	^ (self context
		structure: self comment
		command: self comment editCommandClass new)
			command! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 2/20/2007 15:15'!
buildComment
	^ PBComment new
		title: self context structure title;
		yourself! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 2/9/2007 01:23'!
buildComponent
	^ (self buildDescription asComponentOn: self command)
		onAnswer: [ :result | self execute: result ];
		addValidatedForm;
		yourself! !

!PBPostHtmlView methodsFor: 'private' stamp: 'NickAger 1/22/2012 11:18'!
buildDescription
	^ self command magritteDescription select: [ :each |
		each propertyAt: #public ifAbsent: [ false ] ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'NickAger 6/16/2011 15:47'!
children
	^ super children, (Array with: self component)! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 14:56'!
command
	^ command ifNil: [ command := self buildCommand ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 14:57'!
comment
	^ comment ifNil: [ comment := self buildComment ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 15:11'!
comments
	^ self context structure allCommentsIn: self context! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/19/2008 20:47'!
component
	^ component ifNil: [ component := self buildComponent ]! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 10/25/2010 09:26'!
execute: anEditCommand
	| addCommand |
	comment := component := command := nil.
	anEditCommand ifNil: [ ^ self ].
	addCommand := PRAddCommand new.
	self context command: addCommand.
	addCommand
		name: (addCommand
			uniqueName: 'comment'
			in: self context structure);
		type: PBComment;
		beUnchecked;
		execute.
	self context
		structure: addCommand successAnswer structure
		command: anEditCommand.
	anEditCommand
		beUnchecked;
		execute! !

!PBPostHtmlView methodsFor: 'testing' stamp: 'jf 11/3/2009 11:11'!
isCommentEnabled
	^ self post publication notNil and: [ self post publication + self blog commentTimeout >= GRPlatform current magritteTimeStampClass now ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 2/6/2007 19:29'!
post
	^ post ifNil: [ post := self find: PBPost ]! !

!PBPostHtmlView methodsFor: 'rendering' stamp: 'lr 1/19/2008 20:55'!
renderAuthor: anEntry on: html
	(anEntry isPost or: [ anEntry website isEmptyOrNil ])
		ifTrue: [ ^ super renderAuthor: anEntry on: html ].
	html span class: 'author'; with: [
		html text: 'by '.
		html anchor
			url: anEntry website;
			with: (anEntry author
				ifNil: [ anEntry website ]) ].
	html text: ' '! !

!PBPostHtmlView methodsFor: 'rendering' stamp: 'NickAger 4/27/2011 11:04'!
renderComments: aCollection on: html
	html anchor name: #comments.
	aCollection isEmpty
		ifFalse: [
			html heading level: 2; with: 'Comments' ].
	aCollection do: [ :each |
		html div class: 'comment'; with: [
			html anchor name: each uuid.
			self render: each on: html.
			self renderMeta: each on: html ] ]! !

!PBPostHtmlView methodsFor: 'rendering' stamp: 'tg 9/15/2008 23:56'!
renderContentOn: html
	self render: self post on: html.
	self renderMeta: self post on: html.
	html div class: 'comments'; with: [
		self renderComments: self comments on: html.
		self isCommentEnabled
			ifTrue: [ self renderLeaveCommentOn: html ] ].
	self renderRssOn: html! !

!PBPostHtmlView methodsFor: 'rendering' stamp: 'lr 1/19/2008 20:47'!
renderLeaveCommentOn: html
	html div class: 'leavecomment'; with: [
		html heading level: 2; with: 'Leave your comment'.
		html render: self component ]! !

PRWidget subclass: #PBPostFilter
	instanceVariableNames: 'blog showCount maxItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

PBPostFilter subclass: #PBPostArchive
	instanceVariableNames: 'archive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostArchive class methodsFor: 'testing' stamp: 'lr 11/6/2007 17:54'!
isAbstract
	^ false! !

!PBPostArchive class methodsFor: 'accessing' stamp: 'lr 9/3/2008 11:36'!
label
	^ 'Archive'! !

!PBPostArchive methodsFor: 'accessing' stamp: 'lr 11/6/2007 19:08'!
archive
	^ archive ifNil: [ archive := self buildArchive ]! !

!PBPostArchive methodsFor: 'private' stamp: 'lr 11/6/2007 19:15'!
buildArchive
	| monthMap monthSorted |
	monthMap := Dictionary new.
	self posts do: [ :each |
		(monthMap at: each publication asMonth ifAbsentPut: [ OrderedCollection new ])
			add: each ].
	monthSorted := SortedCollection 
		sortBlock: [ :a :b | a key > b key ].
	monthMap associationsDo: [ :assoc | monthSorted add: assoc ].
	self maxItems notNil
		ifTrue: [ monthSorted := monthSorted first: (monthMap size min: self maxItems) ].
	^ monthSorted! !

!PBPostArchive methodsFor: 'actions' stamp: 'lr 11/6/2007 19:08'!
refresh
	super refresh.
	archive := nil! !

!PBPostArchive methodsFor: 'rendering' stamp: 'jf 11/3/2009 11:12'!
renderBlogOn: html
	self archive isEmpty ifTrue: [ ^ self ].
	html unorderedList: [
		self archive do: [ :assoc |
			html listItem: [
				self 
					renderFilter: assoc value
					with: assoc key name , ' ' , assoc key year greaseString
					on: html ] ] ]! !

!PBPostFilter class methodsFor: 'accessing' stamp: 'lr 9/3/2008 11:46'!
groupLabel
	^ 'Pier Blog'! !

!PBPostFilter methodsFor: 'accessing' stamp: 'lr 11/6/2007 18:16'!
blog
	"Answer the currently browsed blog or nil."
	
	^ blog ifNil: [ blog := self findBlog ]! !

!PBPostFilter methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:45'!
descriptionMaxItems
	<magritteDescription>
	^ MANumberDescription new
		comment: 'The maximum number of items to show.';
		parameterName: 'max-items';
		accessor: #maxItems;
		label: 'Max Items';
		priority: 200;
		default: 10;
		bePositive;
		beInteger;
		yourself! !

!PBPostFilter methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:45'!
descriptionShowCount
	<magritteDescription>
	^ MABooleanDescription new
		parameterName: 'show-count';
		accessor: #showCount;
		label: 'Show Count';
		default: true;
		priority: 210;
		yourself! !

!PBPostFilter methodsFor: 'actions' stamp: 'lr 11/6/2007 18:56'!
filter: aCollection
	| newContext |
	newContext := self context structure: self blog.
	newContext command viewComponent posts: aCollection.
	self context: newContext! !

!PBPostFilter methodsFor: 'private' stamp: 'lr 5/2/2009 10:04'!
findBlog
	^ self context structure findAncestor: [ :each | each isBlog ]! !

!PBPostFilter methodsFor: 'private' stamp: 'lr 5/2/2009 10:04'!
findPost
	^ self context structure findAncestor: [ :each | each isPost ]! !

!PBPostFilter methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 14:07'!
maxItems
	^ maxItems! !

!PBPostFilter methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 14:07'!
maxItems: anObject
	maxItems := anObject! !

!PBPostFilter methodsFor: 'events' stamp: 'lr 11/6/2007 19:01'!
onChangeContext: aContext
	super onChangeContext: aContext.
	self blog = self findBlog
		ifFalse: [ self refresh ]! !

!PBPostFilter methodsFor: 'accessing' stamp: 'lr 11/6/2007 18:12'!
posts
	"Answer the currently displayed blog posts."
	
	^ self blog allPostsIn: self context! !

!PBPostFilter methodsFor: 'actions' stamp: 'lr 11/6/2007 19:02'!
refresh
	blog := nil! !

!PBPostFilter methodsFor: 'rendering' stamp: 'lr 11/6/2007 18:14'!
renderBlogOn: html
	self subclassResponsibility! !

!PBPostFilter methodsFor: 'rendering' stamp: 'lr 11/6/2007 18:45'!
renderContentOn: html
	self blog isNil
		ifTrue: [ html text: '(no blog found)' ]
		ifFalse: [ self renderBlogOn: html ]! !

!PBPostFilter methodsFor: 'rendering' stamp: 'lr 11/6/2007 18:58'!
renderFilter: aCollection with: aRenderBlock on: html
	html anchor
		callback: [ self filter: aCollection ];
		with: aRenderBlock.
	self showCount
		ifTrue: [ html text: ' ('; render: aCollection size; text: ')' ]! !

!PBPostFilter methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 13:51'!
showCount
	^ showCount! !

!PBPostFilter methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 13:51'!
showCount: anObject
	showCount := anObject! !

PBPostFilter subclass: #PBPostRelated
	instanceVariableNames: 'post related'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostRelated class methodsFor: 'testing' stamp: 'lr 12/9/2008 16:25'!
isAbstract
	^ false! !

!PBPostRelated class methodsFor: 'accessing' stamp: 'lr 12/9/2008 16:25'!
label
	^ 'Related'! !

!PBPostRelated methodsFor: 'private' stamp: 'lr 12/9/2008 16:32'!
findRelated
	| other |
	self post isNil
		ifTrue: [ ^ #() ].
	other := ((self posts copyWithout: self post)
		collect: [ :each | each -> (each tags count: [ :tag | self post tags includes: tag ]) ])
		reject: [ :each | each value = 0 ].
	other sort: [ :a :b | a value > b value ].
	self maxItems notNil
		ifTrue: [ other := other first: (other size min: self maxItems) ].
	^ other collect: [ :e | e key ]! !

!PBPostRelated methodsFor: 'events' stamp: 'lr 12/9/2008 16:20'!
onChangeContext: aContext
	super onChangeContext: aContext.
	self post = self findPost
		ifFalse: [ self refresh ]! !

!PBPostRelated methodsFor: 'accessing' stamp: 'lr 12/9/2008 16:19'!
post
	^ post ifNil: [ post := self findPost ]! !

!PBPostRelated methodsFor: 'actions' stamp: 'lr 12/9/2008 16:19'!
refresh
	super refresh.
	post := related := nil! !

!PBPostRelated methodsFor: 'accessing' stamp: 'lr 2/18/2009 15:39'!
related
	^ related ifNil: [ related := self findRelated ]! !

!PBPostRelated methodsFor: 'rendering' stamp: 'lr 5/25/2009 11:38'!
renderBlogOn: html
	self related isEmpty
		ifTrue: [ ^ self ].
	html unorderedList: [
		self related do: [ :each |
			html listItem: [
				html anchor
					goto: (self context structure: each);
					with: [ html html: each menu ] ] ] ]! !

PBPostFilter subclass: #PBPostTags
	instanceVariableNames: 'tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostTags class methodsFor: 'testing' stamp: 'lr 11/6/2007 17:55'!
isAbstract
	^ false! !

!PBPostTags class methodsFor: 'accessing' stamp: 'lr 9/3/2008 11:36'!
label
	^ 'Tags'! !

!PBPostTags methodsFor: 'private' stamp: 'lr 11/6/2007 18:53'!
findTags
	| tagsMap tagsByCount |
	tagsMap := Dictionary new.
	self posts do: [ :post |
		post tags do: [ :tag |
			(tagsMap at: tag ifAbsentPut: [ OrderedCollection new ])
				add: post ] ].
	tagsByCount := SortedCollection
		sortBlock: [ :a :b | a value size < b value size ].
	tagsMap associationsDo: [ :assoc | tagsByCount add: assoc ].
	self maxItems notNil
		ifTrue: [ tagsByCount := tagsByCount last: (tagsByCount size min: self maxItems) ].
	^ tagsByCount asSortedCollection: [ :a :b | a key < b key ]! !

!PBPostTags methodsFor: 'actions' stamp: 'lr 11/6/2007 19:00'!
refresh
	super refresh.
	tags := nil! !

!PBPostTags methodsFor: 'rendering' stamp: 'lr 11/6/2007 18:35'!
renderBlogOn: html
	self tags isEmpty ifTrue: [ ^ self ].
	html unorderedList: [
		self tags do: [ :assoc |
			html listItem: [
				self 
					renderFilter: assoc value
					with: assoc key
					on: html ] ] ]! !

!PBPostTags methodsFor: 'accessing' stamp: 'lr 11/6/2007 18:10'!
tags
	^ tags ifNil: [ tags := self findTags ]! !

PRWidget subclass: #PBPostTicker
	instanceVariableNames: 'numberOfCharacters numberOfPosts blog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostTicker class methodsFor: 'accessing' stamp: 'lr 9/3/2008 11:46'!
groupLabel
	^ 'Pier Blog'! !

!PBPostTicker class methodsFor: 'testing' stamp: 'lr 2/7/2007 14:32'!
isAbstract
	^ false! !

!PBPostTicker class methodsFor: 'accessing' stamp: 'lr 9/3/2008 11:36'!
label
	^ 'Ticker'! !

!PBPostTicker methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 14:11'!
blog
	^ blog! !

!PBPostTicker methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 14:11'!
blog: anObject
	blog := anObject! !

!PBPostTicker methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:45'!
descriptionBlog
	<magritteDescription>
	^ PRStructureDescription new
		addCondition: (MACondition selector: #isBlog) labelled: 'Select a blog as source';
		accessor: #blog;
		label: 'Source';
		priority: 100;
		yourself! !

!PBPostTicker methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:45'!
descriptionNumberOfCharacters
	<magritteDescription>
	^ MANumberDescription new
		comment: 'The maximum number of characters to display of a post.';
		parameterName: 'number-of-characters';
		accessor: #numberOfCharacters;
		label: 'Number of Characters';
		priority: 110;
		default: 200;
		bePositive;
		beInteger;
		yourself! !

!PBPostTicker methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:45'!
descriptionNumberOfPosts
	<magritteDescription>
	^ MANumberDescription new
		comment: 'The maximum number of posts to appear.';
		parameterName: 'number-of-posts';
		accessor: #numberOfPosts;
		label: 'Number of Posts';
		priority: 120;
		default: 3;
		bePositive;
		beInteger;
		yourself! !

!PBPostTicker methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 14:11'!
numberOfCharacters
	^ numberOfCharacters! !

!PBPostTicker methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 14:11'!
numberOfCharacters: anObject
	numberOfCharacters := anObject! !

!PBPostTicker methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 14:11'!
numberOfPosts
	^ numberOfPosts! !

!PBPostTicker methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 14:11'!
numberOfPosts: anObject
	numberOfPosts := anObject! !

!PBPostTicker methodsFor: 'accessing-dynamic' stamp: 'lr 2/18/2009 15:43'!
posts
	| items |
	items := self blog allPostsIn: self context.
	self numberOfPosts isNil
		ifFalse: [ items := items last: (self numberOfPosts min: items size) ].
	^ items reversed! !

!PBPostTicker methodsFor: 'rendering-parts' stamp: 'dc 11/7/2008 17:04'!
renderAuthorForPost: aPost on: html
	aPost author ifNil: [^ self].
	html space.
	html span
		class: 'author';
		with: 'by ', aPost author.
! !

!PBPostTicker methodsFor: 'rendering' stamp: 'damiencassou 11/13/2008 15:36'!
renderContentOn: html
	self blog isNil
		ifTrue: [ ^ html div: '(no blog specified)' ].
	self posts isEmpty
		ifTrue: [ ^ html div: '(no posts available)' ].
	html unorderedList class: 'postticker'; with: [
		self posts do: [ :each |
			html listItem: [
				self renderPost: each on: html ] ] ].
	self renderRssOn: html.! !

!PBPostTicker methodsFor: 'rendering-parts' stamp: 'lr 11/10/2008 13:29'!
renderDateForPost: aPost on: html
	html span class: 'date'; with: aPost publication date! !

!PBPostTicker methodsFor: 'rendering' stamp: 'lr 5/25/2009 15:04'!
renderPost: aPost on: html
	html anchor
		goto: (self context structure: aPost);
		with: [ html html: aPost title ].
	html div class: 'timestamp'; with: [
		self renderDateForPost: aPost on: html.
		self renderTimeForPost: aPost on: html.
		self renderAuthorForPost: aPost on: html ].
	html div
		class: 'summary';
		with: [ html html: (self summaryOf: aPost) ]! !

!PBPostTicker methodsFor: 'rendering' stamp: 'damiencassou 11/13/2008 15:51'!
renderRssOn: html
	"Copy-pasted from PBHtmlView. I tried to refactor but it was not that easy."
	html div class: 'subscribe'; with: [
		html anchor
			url: (self context
				structure: self blog
				view: PBEntriesRssView)
					url;
			with: 'Entries (RSS)'.
		html span class: 'rssComments'; with: [
			html text: ' and '.
				html anchor
					url: (self context
						structure: self blog
						view: PBCommentsRssView)
							url;
					with: 'Comments (RSS)' ]]! !

!PBPostTicker methodsFor: 'rendering-parts' stamp: 'lr 11/10/2008 13:29'!
renderTimeForPost: aPost on: html
	html span class: 'time'; with: aPost publication time! !

!PBPostTicker methodsFor: 'private' stamp: 'NickAger 01/14/2011 14:36'!
summaryOf: aPost
	| input output emptyPosition |
	input := aPost plainText readStream.
	output := WriteStream on: String new.
	"Gemstone and Pharo use 1 based and 0 based stream positioning respectively
	work out what base of stream we have"
	emptyPosition := output position.

	[ input atEnd ] whileFalse: [
		output nextPutAll: (input upTo: $<).
		input upTo: $> ].
	
	self numberOfCharacters isNil ifFalse: [
		output position: (output size min: self numberOfCharacters) + emptyPosition.
		output atEnd
			ifFalse: [ output nextPutAll: '...' ] ].
	^ output contents! !

!PBPostTicker methodsFor: 'updating' stamp: 'lr 6/27/2009 11:10'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	self blog isNil ifTrue: [ ^ self ].
	aHtmlRoot rss
		title: self blog feedTitle;
		url: (self context
			structure: self blog
			view: PBEntriesRssView)
				url! !

PRWidget subclass: #PBRssLinkWidget
	instanceVariableNames: 'blog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBRssLinkWidget class methodsFor: 'accessing' stamp: 'lr 9/3/2008 11:46'!
groupLabel
	^ 'Pier Blog'! !

!PBRssLinkWidget class methodsFor: 'testing' stamp: 'tg 11/8/2007 16:33'!
isAbstract
	^false! !

!PBRssLinkWidget class methodsFor: 'accessing' stamp: 'lr 9/3/2008 11:36'!
label
	^ 'Links'! !

!PBRssLinkWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 14:12'!
blog
	^ blog! !

!PBRssLinkWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 14:12'!
blog: anObject
	blog := anObject! !

!PBRssLinkWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 08:45'!
descriptionBlog
	<magritteDescription>
	^ PRStructureDescription new
		addCondition: (MACondition selector: #isBlog) labelled: 'Select a blog as source';
		accessor: #blog;
		label: 'Source';
		priority: 100;
		yourself! !

!PBRssLinkWidget methodsFor: 'rendering' stamp: 'lr 5/25/2009 11:38'!
renderContentOn: html
	self blog isNil 
		ifTrue: [ ^ html div: '(no blog specified)' ].
	html anchor 
		url: (self context
			structure: self blog
			view: PBEntriesRssView)
				url;
		with: [ html span class: 'rsslink'; with: 'RSS' ]! !

PREmbeddedRenderer subclass: #PBRssEmbeddedRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBRssEmbeddedRenderer methodsFor: 'as yet unclassified' stamp: 'NickAger 8/4/2011 12:49'!
visitComponent: aStructure
	"render links to components, rather than embedding them"
	html anchor
		goto: (self context structure: aStructure);
		with: aStructure title! !

PRCase subclass: #PBBlog
	instanceVariableNames: 'managingEditor webMaster copyright language itemCount feedTitle commentTimeout feedForward socialSharingWidgetClassName'
	classVariableNames: 'Languages'
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBBlog class methodsFor: 'private' stamp: 'lr 1/26/2007 00:48'!
buildLanguages
	^ Dictionary new
		at: 'af' put: 'Afrikaans';
		at: 'sq' put: 'Albanian';
		at: 'eu' put: 'Basque';
		at: 'be' put: 'Belarusian';
		at: 'bg' put: 'Bulgarian';
		at: 'ca' put: 'Catalan';
		at: 'zh-cn' put: 'Chinese (Simplified)';
		at: 'zh-tw' put: 'Chinese (Traditional)';
		at: 'hr' put: 'Croatian';
		at: 'cs' put: 'Czech';
		at: 'da' put: 'Danish';
		at: 'nl' put: 'Dutch';
		at: 'nl-be' put: 'Dutch (Belgium)';
		at: 'nl-nl' put: 'Dutch (Netherlands)';
		at: 'en' put: 'English';
		at: 'en-au' put: 'English (Australia)';
		at: 'en-bz' put: 'English (Belize)';
		at: 'en-ca' put: 'English (Canada)';
		at: 'en-ie' put: 'English (Ireland)';
		at: 'en-jm' put: 'English (Jamaica)';
		at: 'en-nz' put: 'English (New Zealand)';
		at: 'en-ph' put: 'English (Phillipines)';
		at: 'en-za' put: 'English (South Africa)';
		at: 'en-tt' put: 'English (Trinidad)';
		at: 'en-gb' put: 'English (United Kingdom)';
		at: 'en-us' put: 'English (United States)';
		at: 'en-zw' put: 'English (Zimbabwe)';
		at: 'et' put: 'Estonian';
		at: 'fo' put: 'Faeroese';
		at: 'fi' put: 'Finnish';
		at: 'fr' put: 'French';
		at: 'fr-be' put: 'French (Belgium)';
		at: 'fr-ca' put: 'French (Canada)';
		at: 'fr-fr' put: 'French (France)';
		at: 'fr-lu' put: 'French (Luxembourg)';
		at: 'fr-mc' put: 'French (Monaco)';
		at: 'fr-ch' put: 'French (Switzerland)';
		at: 'gl' put: 'Galician';
		at: 'gd' put: 'Gaelic';
		at: 'de' put: 'German';
		at: 'de-at' put: 'German (Austria)';
		at: 'de-de' put: 'German (Germany)';
		at: 'de-li' put: 'German (Liechtenstein)';
		at: 'de-lu' put: 'German (Luxembourg)';
		at: 'de-ch' put: 'German (Switzerland)';
		at: 'el' put: 'Greek';
		at: 'haw' put: 'Hawaiian';
		at: 'hu' put: 'Hungarian';
		at: 'is' put: 'Icelandic';
		at: 'in' put: 'Indonesian';
		at: 'ga' put: 'Irish';
		at: 'it' put: 'Italian';
		at: 'it-it' put: 'Italian (Italy)';
		at: 'it-ch' put: 'Italian (Switzerland)';
		at: 'ja' put: 'Japanese';
		at: 'ko' put: 'Korean';
		at: 'mk' put: 'Macedonian';
		at: 'no' put: 'Norwegian';
		at: 'pl' put: 'Polish';
		at: 'pt' put: 'Portuguese';
		at: 'pt-br' put: 'Portuguese (Brazil)';
		at: 'pt-pt' put: 'Portuguese (Portugal)';
		at: 'ro' put: 'Romanian';
		at: 'ro-mo' put: 'Romanian (Moldova)';
		at: 'ro-ro' put: 'Romanian (Romania)';
		at: 'ru' put: 'Russian';
		at: 'ru-mo' put: 'Russian (Moldova)';
		at: 'ru-ru' put: 'Russian (Russia)';
		at: 'sr' put: 'Serbian';
		at: 'sk' put: 'Slovak';
		at: 'sl' put: 'Slovenian';
		at: 'es' put: 'Spanish';
		at: 'es-ar' put: 'Spanish (Argentina)';
		at: 'es-bo' put: 'Spanish (Bolivia)';
		at: 'es-cl' put: 'Spanish (Chile)';
		at: 'es-co' put: 'Spanish (Colombia)';
		at: 'es-cr' put: 'Spanish (Costa Rica)';
		at: 'es-do' put: 'Spanish (Dominican Republic)';
		at: 'es-ec' put: 'Spanish (Ecuador)';
		at: 'es-sv' put: 'Spanish (El Salvador)';
		at: 'es-gt' put: 'Spanish (Guatemala)';
		at: 'es-hn' put: 'Spanish (Honduras)';
		at: 'es-mx' put: 'Spanish (Mexico)';
		at: 'es-ni' put: 'Spanish (Nicaragua)';
		at: 'es-pa' put: 'Spanish (Panama)';
		at: 'es-py' put: 'Spanish (Paraguay)';
		at: 'es-pe' put: 'Spanish (Peru)';
		at: 'es-pr' put: 'Spanish (Puerto Rico)';
		at: 'es-es' put: 'Spanish (Spain)';
		at: 'es-uy' put: 'Spanish (Uruguay)';
		at: 'es-ve' put: 'Spanish (Venezuela)';
		at: 'sv' put: 'Swedish';
		at: 'sv-fi' put: 'Swedish (Finland)';
		at: 'sv-se' put: 'Swedish (Sweden)';
		at: 'tr' put: 'Turkish';
		at: 'uk' put: 'Ukranian';
		yourself! !

!PBBlog class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
canBeParentOf: aClass
	^ aClass includesBehavior: PBPost! !

!PBBlog class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
isAbstract
	^ false! !

!PBBlog class methodsFor: 'accessing' stamp: 'lr 1/8/2010 22:04'!
label
	^ 'Blog'! !

!PBBlog class methodsFor: 'accessing-resources' stamp: 'lr 1/26/2007 00:48'!
languages
	^ Languages ifNil: [ Languages := self buildLanguages ]! !

!PBBlog methodsFor: 'visiting' stamp: 'lr 1/15/2007 20:05'!
accept: aVisitor
	aVisitor visitBlog: self! !

!PBBlog methodsFor: 'accessing-dynamic' stamp: 'jf 11/3/2009 11:10'!
allCommentsIn: aContext
	"Answer all the comments in choronological order."

	^ ((aContext enumeratorFor: self) all
		select: [ :each |
			each isComment
				and: [ each publication notNil
				and: [ each publication <= GRPlatform current magritteTimeStampClass now ] ] ])
		sort: [ :a :b | a publication < b publication ];
		yourself! !

!PBBlog methodsFor: 'accessing-dynamic' stamp: 'jf 11/3/2009 11:10'!
allPostsIn: aContext
	"Answer all the published posts in choronological order."

	^ ((aContext enumeratorFor: self)
		select: [ :each |
			each isPost
				and: [ each publication notNil
				and: [ each publication <= GRPlatform current magritteTimeStampClass now ] ] ])
		sort: [ :a :b | a publication < b publication ];
		yourself! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/20/2007 15:23'!
commentTimeout
	^ commentTimeout ifNil: [ commentTimeout := 14 days ]! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/6/2007 19:45'!
commentTimeout: aDuration
	commentTimeout := aDuration! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/19/2007 19:18'!
copyright
	^ copyright! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/19/2007 19:18'!
copyright: aString
	copyright := aString! !

!PBBlog methodsFor: 'accessing-commands' stamp: 'lr 4/6/2010 16:58'!
defaultChildName
	| date code |
	date := Date today.
	code := #( year 4 $- monthIndex 2 $- dayOfMonth 2 ) readStream.
	^ String streamContents: [ :stream |
		[ code atEnd ] whileFalse: [
			stream nextPutAll: ((date perform: code next)
				printPaddedWith: $0 to: code next).
			code atEnd
				ifFalse: [ stream nextPut: code next ] ] ]! !

!PBBlog methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:32'!
descriptionCommentTimeout
	<magritteDescription>
	^ MADurationDescription new
		accessor: #commentTimeout;
		label: 'Comment Timeout';
		priority: 370;
		comment: 'How long should it be possible to post comments.';
		beRequired;
		beEditable;
		yourself! !

!PBBlog methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:32'!
descriptionCopyright
	<magritteDescription>
	^ MAStringDescription new
		accessor: #copyright;
		label: 'Copyright';
		priority: 350;
		comment: 'Copyright notice for content in the channel.';
		beEditable;
		yourself! !

!PBBlog methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:32'!
descriptionDocument
	<magritteDescription>
	^ super descriptionDocument
		label: 'Description';
		yourself! !

!PBBlog methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:32'!
descriptionFeedForward
	<magritteDescription>
	^ MAStringDescription new
		accessor: #feedForward;
		label: 'Feed Forward';
		priority: 315;
		comment:
				'The url to forward the feed to. This is useful when used together with services such as FeedBurner or Google AdSense. The original feed can be reached by concatenating the original URL with ''&noforward.''';
		beEditable;
		yourself! !

!PBBlog methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:32'!
descriptionFeedTitle
	<magritteDescription>
	^ MAStringDescription new
		accessor: #feedTitle;
		label: 'Feed Title';
		priority: 310;
		comment: 'The title of the channel.';
		beEditable;
		yourself! !

!PBBlog methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:32'!
descriptionItemCount
	<magritteDescription>
	^ MANumberDescription new
		comment: 'The number of items to appear in the feed.';
		accessor: #itemCount;
		label: 'Item Count';
		priority: 370;
		beRequired;
		beEditable;
		bePositive;
		beInteger;
		yourself! !

!PBBlog methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:35'!
descriptionLanguage
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #language;
		label: 'Language';
		priority: 360;
		comment: 'The language the channel is written in.';
		reference:
				(MAStringDescription new
						stringWriter: self;
						yourself);
		options: self class languages keys;
		default: 'en';
		beRequired;
		beEditable;
		beSorted;
		yourself! !

!PBBlog methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:32'!
descriptionManagingEditor
	<magritteDescription>
	^ MAStringDescription new
		accessor: #managingEditor;
		label: 'Managing Editor';
		priority: 330;
		comment: 'Email address for person responsible for editorial content.';
		beEditable;
		yourself! !

!PBBlog methodsFor: 'accessing-description' stamp: 'NickAger 2/2/2012 18:14'!
descriptionSocialSharingWidgetClassName
	<magritteDescription>
	^ MASymbolDescription new
		accessor: #socialSharingWidgetClassName;
		label: 'Social sharing class';
		priority: 330;
		comment: 'Class for social sharing widgets, that is a class which creates twitter, facebook widgets';
		beEditable;
		yourself! !

!PBBlog methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 08:32'!
descriptionWebMaster
	<magritteDescription>
	^ MAStringDescription new
		accessor: #webMaster;
		label: 'Web Master';
		priority: 340;
		comment: 'Email address for person responsible for technical issues relating to channel.';
		beEditable;
		yourself! !

!PBBlog methodsFor: 'accessing' stamp: 'tg 9/16/2008 16:02'!
feedForward
	^ feedForward! !

!PBBlog methodsFor: 'accessing' stamp: 'tg 9/16/2008 16:02'!
feedForward: aString
	feedForward := aString! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:45'!
feedTitle
	^ feedTitle! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:41'!
feedTitle: aString
	feedTitle := aString! !

!PBBlog methodsFor: 'testing' stamp: 'lr 1/15/2007 21:06'!
isBlog
	^ true! !

!PBBlog methodsFor: '*pier-blog-seaside' stamp: 'lr 1/29/2007 13:50'!
isValidView: aComponentClass in: aContext
	^ super viewComponentClass ~= aComponentClass! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:40'!
itemCount
	^ itemCount ifNil: [ itemCount := 10 ]! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:41'!
itemCount: anInteger
	itemCount := anInteger! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/26/2007 00:33'!
language
	^ language! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/26/2007 00:54'!
language: aString
	language := aString! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:16'!
managingEditor
	^ managingEditor! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
managingEditor: anEditor
	managingEditor := anEditor! !

!PBBlog methodsFor: 'accessing' stamp: 'NickAger 2/2/2012 18:28'!
socialSharingWidgetClass: aClassName
	self greaseDeprecatedApi: 'PBBlog>>#socialSharingWidgetClass:' details: 'use PBBlog>>#socialSharingWidgetClassName: instead.'.
	
	self socialSharingWidgetClassName: aClassName! !

!PBBlog methodsFor: 'accessing' stamp: 'NickAger 2/2/2012 18:15'!
socialSharingWidgetClassName
	^ socialSharingWidgetClassName! !

!PBBlog methodsFor: 'accessing' stamp: 'NickAger 2/2/2012 18:11'!
socialSharingWidgetClassName: anObjectName
	socialSharingWidgetClassName := anObjectName! !

!PBBlog methodsFor: '*pier-blog-seaside' stamp: 'lr 2/5/2007 19:38'!
viewComponentClass
	^ PBBlogHtmlView! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
webMaster
	^ webMaster! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
webMaster: aString
	webMaster := aString! !

!PBBlog methodsFor: 'private' stamp: 'NickAger 1/22/2012 18:11'!
write: anObject description: aDescription
	^ self class languages at: anObject ifAbsent: [ anObject ]! !

PRCase subclass: #PBEntry
	instanceVariableNames: 'uuid author publication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

PBEntry subclass: #PBComment
	instanceVariableNames: 'website'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBComment class methodsFor: 'testing' stamp: 'lr 1/15/2007 20:04'!
canBeChildOf: aClass
	^ aClass includesBehavior: PBPost! !

!PBComment class methodsFor: 'testing' stamp: 'lr 1/15/2007 20:04'!
canBeParentOf: aClass
	^ false! !

!PBComment class methodsFor: 'accessing' stamp: 'lr 1/8/2010 22:05'!
label
	^ 'Blog Comment'! !

!PBComment methodsFor: 'visiting' stamp: 'lr 1/15/2007 16:08'!
accept: aVisitor
	aVisitor visitComment: self! !

!PBComment methodsFor: 'private' stamp: 'lr 5/22/2007 22:47'!
confirmation
	^ false! !

!PBComment methodsFor: 'private' stamp: 'lr 5/22/2007 22:47'!
confirmation: aBoolean! !

!PBComment methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:32'!
descriptionAuthor
	<magritteDescription>
	^ super descriptionAuthor
		propertyAt: #public put: true;
		yourself! !

!PBComment methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:32'!
descriptionConfirmation
	<magritteDescription>
	^ MABooleanDescription new
		addCondition: (MACondition selector: #yourself) labelled: 'Please, confirm submission by clicking the checkbox';
		checkboxLabel: 'Confirm submission by clicking the checkbox';
		propertyAt: #public put: true;
		accessor: #confirmation;
		label: 'Confirmation';
		priority: 600;
		beEditable;
		yourself! !

!PBComment methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:32'!
descriptionDocument
	<magritteDescription>
	^ super descriptionDocument
		propertyAt: #public put: true;
		beRequired;
		yourself! !

!PBComment methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:32'!
descriptionWebsite
	<magritteDescription>
	^ MAStringDescription new
		addCondition: (MACondition selector: #matches: argument: '#*.##*') labelled: 'Please make sure to enter a valid URL';
		comment: 'The URL to the blog or personal website of the author';
		propertyAt: #public put: true;
		accessor: #website;
		label: 'Website';
		priority: 340;
		beEditable;
		yourself! !

!PBComment methodsFor: 'initialization' stamp: 'jf 10/28/2009 23:43'!
initialize
	super initialize.
	self publication: GRPlatform current magritteTimeStampClass now! !

!PBComment methodsFor: 'testing' stamp: 'lr 1/14/2007 13:23'!
isComment
	^ true! !

!PBComment methodsFor: 'accessing' stamp: 'lr 1/19/2008 20:44'!
website
	^ website! !

!PBComment methodsFor: 'accessing' stamp: 'lr 1/5/2013 16:10'!
website: aString
	website := (aString isEmptyOrNil or: [ aString includesSubString: '://' ])
		ifFalse: [ website := 'http://' , aString ]
		ifTrue: [ aString ]! !

!PBEntry class methodsFor: 'testing' stamp: 'lr 1/14/2007 12:36'!
isAbstract
	^ self name = #PBEntry! !

!PBEntry methodsFor: 'visiting' stamp: 'pmm 1/26/2007 23:34'!
accept: aVisitor
	aVisitor visitEntry: self! !

!PBEntry methodsFor: 'accessing-dynamic' stamp: 'jf 11/3/2009 11:10'!
allCommentsIn: aContext
	"Answer all the published comments in choronological order."

	^ ((aContext enumeratorFor: self) all
		select: [ :each |
			each isComment
				and: [ each publication notNil
				and: [ each publication <= GRPlatform current magritteTimeStampClass now ] ] ])
		sort: [ :a :b | a publication < b publication ];
		yourself! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 2/18/2009 16:23'!
author
	^ author ifNil: [ author := self findAuthor ]! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/14/2007 12:36'!
author: aString
	author := aString! !

!PBEntry methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:32'!
descriptionAuthor
	<magritteDescription>
	^ MAStringDescription new
		accessor: #author;
		comment: 'The author of the entry.';
		label: 'Author';
		priority: 300;
		beRequired;
		beEditable;
		yourself! !

!PBEntry methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:32'!
descriptionPublication
	<magritteDescription>
	^ MATimeStampDescription new
		accessor: #publication;
		comment: 'The publication date of the entry.';
		label: 'Publication';
		priority: 310;
		beEditable;
		yourself! !

!PBEntry methodsFor: 'private' stamp: 'NickAger 7/2/2011 21:52'!
findAuthor
	| context user |
	context := PRCurrentContext value
		ifNil: [ ^ nil ].
	user := (context
		propertyAt: #user
		ifAbsent: [ ^ nil ])
			ifNil: [ ^ nil ].
	^ user fullName! !

!PBEntry methodsFor: 'copying' stamp: 'lr 8/17/2007 08:03'!
postCopy
	super postCopy.
	uuid := nil! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/19/2007 18:40'!
publication
	^ publication! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/19/2007 18:40'!
publication: aTimeStamp
	publication := aTimeStamp! !

!PBEntry methodsFor: 'accessing' stamp: 'jf 11/3/2009 11:13'!
uuid
	^ uuid ifNil: [ uuid := SmallInteger maxVal atRandom greaseString ]! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:12'!
uuid: anObject
	uuid := anObject! !

PBEntry subclass: #PBPost
	instanceVariableNames: 'sourceUrl sourceTitle enclosure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBPost class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
canBeChildOf: aClass
	^ aClass includesBehavior: PBBlog! !

!PBPost class methodsFor: 'accessing' stamp: 'lr 1/8/2010 22:05'!
label
	^ 'Blog Post'! !

!PBPost methodsFor: 'visiting' stamp: 'lr 1/15/2007 16:08'!
accept: aVisitor
	aVisitor visitPost: self! !

!PBPost methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:32'!
descriptionEnclosure
	<magritteDescription>
	^ PRStructureDescription new
		addCondition: (MACondition selector: #isFile) labelled: 'Enclosure must be a file';
		comment: 'A media object that is attached to the item.';
		accessor: #enclosure;
		label: 'Enclosure';
		priority: 350;
		beEditable;
		yourself! !

!PBPost methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:32'!
descriptionSourceTitle
	<magritteDescription>
	^ MAStringDescription new
		accessor: #sourceTitle;
		comment: 'The title of the RSS channel the item came from.';
		label: 'Source Title';
		priority: 330;
		beEditable;
		yourself! !

!PBPost methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:32'!
descriptionSourceUrl
	<magritteDescription>
	^ MAStringDescription new
		accessor: #sourceUrl;
		comment: 'The URL of the RSS channel the item came from.';
		label: 'Source URL';
		priority: 340;
		beEditable;
		yourself! !

!PBPost methodsFor: 'accessing-descriptions' stamp: 'NickAger 1/22/2012 08:32'!
descriptionTags
	<magritteDescription>
	^ super descriptionTags
		priority: 110;
		beEditable;
		yourself! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/27/2007 18:30'!
enclosure
	^ enclosure! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
enclosure: aFile
	enclosure := aFile! !

!PBPost methodsFor: 'testing' stamp: 'lr 1/14/2007 13:44'!
isPost
	^ true! !

!PBPost methodsFor: '*pier-blog-seaside' stamp: 'lr 1/29/2007 13:50'!
isValidView: aComponentClass in: aContext
	^ super viewComponentClass ~= aComponentClass! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/18/2009 16:28'!
sourceTitle
	^ sourceTitle! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
sourceTitle: aString
	sourceTitle := aString! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/18/2009 16:28'!
sourceUrl
	^ sourceUrl! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
sourceUrl: aString
	sourceUrl := aString! !

!PBPost methodsFor: '*pier-blog-seaside' stamp: 'lr 2/5/2007 19:38'!
viewComponentClass
	^ PBPostHtmlView! !
